#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n,q;
    cin>>n>>q;
    long long int tr=0;
    vector<int> d(n);//dan
    vector<int> p(n);//kolicina
    vector<int> k(q);//pitanja
    vector<int> z(n);//izlaz
    for(int i=0;i<n;i++){
        cin>>d[i];
        cin>>p[i];
    }
    for(int i=0;i<q;i++)
        cin>>k[i];
        int di=0;
    for(int i=0;i<n;i++){
        if(d[di]==i)
            tr+=p[di++];
        z[i]=z[i-1]+(tr!=0);
    }
    for(int i=0;i<n;i++)
        cout<<z[k[i]];
}